Attribute VB_Name = "Database"
Public Function CheckPwd(username As String, Password As String) As Boolean
    If FSO.FileExists(App.Path & "\USERS\" & username & "\PASSWORD.TXT") = True Then
        If LCase(Trim(OpenFile("USERS\" & username & "\PASSWORD.TXT"))) = LCase(Trim(Password)) Then
            CheckPwd = True
        Else
            CheckPwd = False
        End If
    End If
End Function

Function OpenFile(Path As String) As String
    If FSO.FileExists(App.Path & "\" & Path) = True Then
        OpenFile = FSO.OpenTextFile(App.Path & "\" & Path, ForReading).ReadAll
    End If
End Function

Public Function UserObject(username As String) As String
    Dim TheFile As String
    If FSO.FileExists(App.Path & "\USERS\" & username & "\OBJECT.TXT") = True Then
        TheFile = OpenFile("USERS\" & username & "\OBJECT.TXT")
        If UBound(Split(TheFile, Chr(13))) >= 10 Then
            UserObject = "name=" & Split(TheFile, Chr(13))(0) & Chr(13) & _
            "email=" & Split(TheFile, Chr(13))(1) & Chr(13) & _
            "figure=" & Split(TheFile, Chr(13))(2) & Chr(13) & _
            "birthday=" & Split(TheFile, Chr(13))(3) & Chr(13) & _
            "phonenumber=" & Split(TheFile, Chr(13))(4) & Chr(13) & _
            "customData=" & Split(TheFile, Chr(13))(5) & Chr(13) & _
            "had_read_agreement=" & Split(TheFile, Chr(13))(6) & Chr(13) & _
            "sex=" & Split(TheFile, Chr(13))(7) & Chr(13) & _
            "country=" & Split(TheFile, Chr(13))(8) & Chr(13) & _
            "has_special_rights=" & Split(TheFile, Chr(13))(9) & Chr(13) & _
            "badge_type=" & Split(TheFile, Chr(13))(10) & Chr(13)
        End If
    End If
End Function

Public Function UserExists(ByVal username As String) As Boolean

    If FSO.FolderExists(App.Path & "\USERS\" & LCase(Trim(username))) = True Then
        UserExists = True
    Else
        UserExists = False
    End If

End Function

Public Function GetCredits(username As String) As Integer
    If FSO.FileExists(App.Path & "\USERS\" & username & "\CREDITS.TXT") = True Then
        GetCredits = CInt(OpenFile("USERS\" & username & "\CREDITS.TXT"))
    End If
End Function

Public Function GetFigure(username As String) As String
    Dim TheFile As String
    If FSO.FileExists(App.Path & "\USERS\" & username & "\OBJECT.TXT") = True Then
        TheFile = OpenFile("USERS\" & username & "\OBJECT.TXT")
        GetFigure = Split(TheFile, Chr(13))(2) & Chr(13)
    End If
End Function

Public Function GetMission(username As String) As String
    Dim TheFile As String
    If FSO.FileExists(App.Path & "\USERS\" & username & "\OBJECT.TXT") = True Then
        TheFile = OpenFile("USERS\" & username & "\OBJECT.TXT")
        GetMission = Split(TheFile, Chr(13))(5) & Chr(13)
    End If
End Function

Public Function GetSex(username As String) As String
    Dim TheFile As String
    If FSO.FileExists(App.Path & "\USERS\" & username & "\OBJECT.TXT") = True Then
        TheFile = OpenFile("USERS\" & username & "\OBJECT.TXT")
        If Trim(Split(TheFile, Chr(13))(7)) = "Male" Then
            GetSex = "m"
        Else
            GetSex = "f"
        End If
    End If
End Function
Public Function GetLastTime(username As String) As String
    If FSO.FileExists(App.Path & "\USERS\" & username & "\TIME.TXT") = True Then
        GetLastTime = OpenFile("USERS\" & username & "\TIME.TXT")
    Else
        GetLastTime = Now
    End If
End Function
Public Function GetMSG(username As String) As String
    If FSO.FileExists(App.Path & "\USERS\" & username & "\MESSENGER.TXT") = True Then
        GetMSG = OpenFile("USERS\" & username & "\MESSENGER.TXT")
    End If
End Function

Public Function GetUserCount(flat As Integer) As Integer
    If FSO.FileExists(App.Path & "\FLATFILES\" & flat & "\USERCOUNT.TXT") = True Then
        GetUserCount = OpenFile("FLATFILES\" & flat & "\USERCOUNT.TXT")
    End If
End Function

Public Function FlatProperties(Flatnumber As String) As String
    Dim TheFile As String
    If FSO.FileExists(App.Path & "\FLATFILES\" & Flatnumber & "\PROPERTIES.TXT") = True Then
        TheFile = OpenFile("FLATFILES\" & Flatnumber & "\PROPERTIES.TXT")
        FlatProperties = Split(TheFile, Chr(13))(0) & Chr(13)
        FlatProperties = FlatProperties & Split(TheFile, Chr(13))(1) & Chr(13)
        FlatProperties = FlatProperties & Split(TheFile, Chr(13))(2) & Chr(13)
        FlatProperties = FlatProperties & Split(TheFile, Chr(13))(3) & Chr(13)
        FlatProperties = FlatProperties & Split(TheFile, Chr(13))(4) & Chr(13)
    End If
End Function
Public Function FlatRights(Flatnumber As String, username As String) As Boolean
    Dim TheFile As String
    Dim userswithrights As Integer
    Dim i As Integer
    
    If FSO.FileExists(App.Path & "\FLATFILES\" & Flatnumber & "\RIGHTS.TXT") = True Then
        TheFile = OpenFile("FLATFILES\" & Flatnumber & "\RIGHTS.TXT")
        userswithrights = fCount(TheFile, Chr(13))
        For i = 0 To userswithrights
            If LCase(username) = LCase(Split(TheFile, Chr(13))(i)) Then
                FlatRights = True
                GoTo ReturnFunction
            End If
        Next i
    End If
ReturnFunction:
End Function
Private Function fCount(ByVal sString As String, ByVal sDelim As String) As Long
    fCount = 0
    On Error Resume Next
    fCount = UBound(Split(sString, sDelim))
End Function

Public Function Register(SData As String)
   Dim SplitData As Variant
   Dim i As Integer
   Dim TheData As String
   Dim TheUser As String
   SplitData = Split(SData, Chr(13))
    TheUser = CStr(Split(SplitData(0), "=")(1))
    FSO.CreateFolder (App.Path & "\USERS\" & LCase(TheUser))
    DoEvents
    
    FSO.OpenTextFile(App.Path & "\USERS\" & LCase(TheUser) & "\OBJECT.TXT", ForWriting, True).Write ("" & _
        Split(SplitData(0), "=")(1) & Chr(13) & _
        Split(SplitData(2), "=")(1) & Chr(13) & _
        Right(SplitData(3), Len(SplitData(3)) - 7) & Chr(13) & _
        Split(SplitData(5), "=")(1) & Chr(13) & _
        Split(SplitData(6), "=")(1) & Chr(13) & _
        Split(SplitData(7), "=")(1) & Chr(13) & _
        Split(SplitData(8), "=")(1) & Chr(13) & _
        Split(SplitData(9), "=")(1) & Chr(13) & _
        Split(SplitData(10), "=")(1) & Chr(13) & _
        "0" & Chr(13) & _
        "0")
    DoEvents
    
    FSO.OpenTextFile(App.Path & "\USERS\" & LCase(TheUser) & "\PASSWORD.TXT", ForWriting, True).Write (Split(SplitData(1), "=")(1))

    DoEvents
    
    FSO.OpenTextFile(App.Path & "\USERS\" & LCase(TheUser) & "\CREDITS.TXT", ForWriting, True).Write ("0")
    DoEvents
    
    FSO.OpenTextFile(App.Path & "\USERS\" & LCase(TheUser) & "\MESSENGER.TXT", ForWriting, True).Write (TheUser)
    
    FSO.OpenTextFile(App.Path & "\USERS\" & LCase(TheUser) & "\STRIP.TXT", ForWriting, True).Write ("0")
End Function

Public Function Update(SData As String)
   Dim SplitData As Variant
   Dim i As Integer
   Dim TheData As String
   Dim TheUser As String
   Dim ISAd As Integer
   Dim Buffer As String
   SplitData = Split(SData, Chr(13))
    TheUser = CStr(Split(SplitData(0), "=")(1))
    If IsAdmin(TheUser) = True Then
        ISAd = 1
    End If
    
    Buffer = "" & _
    Split(SplitData(0), "=")(1) & Chr(13) & _
    Split(SplitData(2), "=")(1) & Chr(13) & _
    Right(SplitData(3), Len(SplitData(3)) - 7) & Chr(13) & _
    Split(SplitData(5), "=")(1) & Chr(13) & _
    Split(SplitData(6), "=")(1) & Chr(13) & _
    Split(SplitData(7), "=")(1) & Chr(13) & _
    Split(SplitData(8), "=")(1) & Chr(13) & _
    Split(SplitData(9), "=")(1) & Chr(13) & _
    Split(SplitData(10), "=")(1) & Chr(13) & _
    ISAd & Chr(13) & _
    BadgeType(TheUser)
        
    FSO.OpenTextFile(App.Path & "\USERS\" & LCase(TheUser) & "\OBJECT.TXT", ForWriting, True).Write (Buffer)

    
    FSO.OpenTextFile(App.Path & "\USERS\" & LCase(TheUser) & "\PASSWORD.TXT", ForWriting, True).Write (Split(SplitData(1), "=")(1))
    
End Function

Public Function IsAdmin(username As String) As Boolean
    Dim TheFile As String
    If FSO.FileExists(App.Path & "\USERS\" & username & "\OBJECT.TXT") = True Then
        TheFile = OpenFile("USERS\" & username & "\OBJECT.TXT")
        If Split(TheFile, Chr(13))(9) & Chr(13) = 1 Then
            IsAdmin = True
            Exit Function
        End If
    End If
    IsAdmin = False
End Function

Public Function BadgeType(username As String) As String
    Dim TheFile As String
    If FSO.FileExists(App.Path & "\USERS\" & username & "\OBJECT.TXT") = True Then
        TheFile = OpenFile("USERS\" & username & "\OBJECT.TXT")
        BadgeType = CStr(Split(TheFile, Chr(13))(10))
    End If
End Function

Public Function Usercount(rconnections As Integer, flat As Integer)
If FSO.FileExists(App.Path & "\FLATFILES\" & flat & "\USERCOUNT.TXT") = True Then
    Open App.Path & "\FLATFILES\" & flat & "\USERCOUNT.TXT" For Output As #1
        Print #1, Trim(rconnections)
    Close #1
End If
End Function

Public Function GetRoomHeightmap(roomid As String) As String
    Dim TheFile As String
    If FSO.FileExists(App.Path & "\FLATFILES\" & roomid & "\HEIGHTMAP.TXT") = True Then
        TheFile = OpenFile("FLATFILES\" & roomid & "\HEIGHTMAP.TXT")
        GetRoomHeightmap = TheFile
    End If
End Function
